# Postman Collection Generator


## Introduction

Postman provides automated functional tests against the TMZ api.  The Postman application can be run via commandline, the web or the desktop application.  API requests are stored as part of a "collection" which can be represented in JSON format.  

Maintaining a complete collection can be tedious and difficult due to the rapid addition of new endpoints to the API.

This script provides an automated way of generating a collection in JSON format from all existing request and response messages within the TMZ application.  Basic unit tests, descriptions and request payloads are also generated. 


## Usage Example

Run the provided script on the commandline, which will generate a `collection.json` file.  This file can be imported directly to the postman application or run via the commandline using the `newman` package.

Example newman command `newman run collection.json -k --color -e dev-environment.json`


## Environments

Postman supports environment variables which are injected into any request that references them.  This includes the api endpoint, hostname and access tokens.

The included environment file `dev-environment.json` is preconfigured to use the TMZ dev environment but this can be changed in postman or in the file directly, if you need to test a different environment.


## Access Tokens

A valid access token must be set in the postman environment in order to make API calls.  To get a valid access token, you must first login to the CMS application (part of the tmz monorepo) and then copy the access token from local storage (key `pbjx.accessToken`) and copy it into the environment settings or the `dev-environment.json` file if you are using newman to run the tests from the CLI.


## Unit Tests

Postman supports unit tests, written in javascript and executed in the postman sandbox which is running NodeJS.  These tests are on a per-request basis, but global unit tests can also be created.  While some basic unit tests are auto generated by this script, you may which to expand on a particular unit test.  This can be done in the postman application, and then exported back to json to be run on the CLI.

More information can be found here <https://www.getpostman.com/docs/postman/scripts/test_scripts> .


## Installation

+ Install php 7.2 or later.  On mac this can be done using the command `brew install php72`.
+ Install NodeJS 8 or later using the 'nvm' or 'n' packages from npm.  e.g. `npm i -g n`
+ Install the desktop version of postman, found on the postman website.  https://www.getpostman.com/
+ If you will be running the tests on the commandline, install the newman command like so: `npm i -g newman`
